<?php

namespace  Drupal\file_downloader\Controller;

use Drupal\file\FileInterface;
use Drupal\file_downloader\Entity\DownloadOptionConfigInterface;
use Drupal\media\MediaInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * Class DownloadOptionPluginController
 *
 * @package Drupal\file_downloader\Controller
 */
class DownloadOptionPluginController {

  /**
   * Callback to download a file based on the given Download option Configuration.
   *
   * @param \Drupal\file_downloader\Entity\DownloadOptionConfigInterface $downloadOptionConfig
   *  Download option configuration for getting the plugin.
   * @param \Drupal\file\FileInterface $file
   *  File object which will be downloaded based on the plugin.
   * @param \Symfony\Component\HttpFoundation\Request $request
   *  Contains the request from the route.
   */
  public function downloadFile(DownloadOptionConfigInterface $download_option_config, FileInterface $file, Request $request){
    $downloadOptionPlugin = $download_option_config->getPlugin();
    return $downloadOptionPlugin->deliver($file, $download_option_config);
  }
}