<?php

namespace Drupal\file_downloader\Entity;

use Drupal\Core\Config\Entity\ConfigEntityInterface;

/**
 * Provides an interface for defining Download option config entities.
 */
interface DownloadOptionConfigInterface extends ConfigEntityInterface {

  /**
   * Returns the plugin instance.
   *
   * @return \Drupal\file_downloader\DownloadOptionPluginInterface
   *   The plugin instance for this download option configuration.
   */
  public function getPlugin();

  /**
   * Returns the plugin ID.
   *
   * @return string
   *   The plugin ID for this download option configuration.
   */
  public function getPluginId();

  /**
   * @return string
   *  The allowed extensions for this download option configuration.
   */
  public function getExtensions();
}
